package enseirb.myinpulse.api;

import enseirb.myinpulse.api.datatypes.Appointment;

import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.web.bind.annotation.*;

@SpringBootApplication
@RestController
public class SharedApi {

    /**
     * TODO: It does not looks like a good id to have the title and the date in the url. What even
     * TODO: is the title btw ? if this is the LC section, wouldn't it be better to use an ID ?
     * TODO: choose return type, cf comment in LCSection
     *
     * <p>Endpoint used to get the data inside the lean canvas
     *
     * @return a list of lean canvas sections
     */
    @GetMapping("/shared/project/lcsection/{projectId}/{title}/{date}")
    public void getLCSection(
            @PathVariable("projectId") String projectId,
            @PathVariable("title") String title,
            @PathVariable("date") String date) {}

    /**
     * TODO
     *
     * <p>Endpoint used to get entrepreneurs details
     *
     * @return a list of all entrepreneurs in a project
     */
    @GetMapping("/shared/entrepreneurs/{projectId}")
    public void getEntrepreneursByProjectId(@PathVariable int projectId) {}

    /**
     * TODO: is it really useful for the admin ? We can already get all the project of the current
     * administrator.
     *
     * <p>Endpoint used to get the administrator of a project.
     *
     * @return a list of all project managed by the current admin user
     */
    @GetMapping("/shared/projects/admin/{projectId}")
    public void getAdminByProjectId(@PathVariable int projectId) {}

    /**
     * TODO: Should it really be all appointments? all future appointments ? a flag to choose \\
     * TODO: between both ?
     *
     * <p>Endpoint used to get all appointments of a single project.
     *
     * @return a list of all appointments.
     */
    @GetMapping("/shared/projects/appointments/{projectId}")
    public void getAppointmentsByProjectId(@PathVariable int projectId) {}

    /**
     * TODO: Shouldn't the last two parameters be swapped ?
     *
     * <p>Endpoint used to generate a PDF report
     *
     * @return a PDF file? TODO: how does that works ?
     */
    @GetMapping("/shared/projects/appointments/report/{appointmentId}")
    public void getPDFReport(@PathVariable int appointmentId) {}

    /**
     * TODO
     *
     * <p>
     *
     * @return a list of all project managed by the current admin user
     */
    @PostMapping("/shared/appointment/request")
    public void createAppointmentRequest(@RequestBody Appointment appointment) {}
}
